#!/usr/bin/perl

use utf8;
use strict;

# "1.150n"-"1.199n"
my $VER="V.1.158n(nanakochi123456)";
my $tarball="power110702.tar.gz";
my $data_update=<<EOM;
<li>2011/6/21 14:49 節電事例に色々追記してあります。</li>
<li>2011/6/21 19:02 ９月３０日までのデータを入力した。</li>
<li>2011/6/21 06:21 東京電力でんき予報速報へのリンクをした。</li>
<li>2011/6/19 09:30 東京電力の6月20日以降のグループに切り替えをした。</li>
<li>2011/6/16 20:15 節電の心得に鉄道を追加した。</li>
<li>2011/6/13 18:55 食事による節電事例を追加した。</li>
<li>2011/6/11 05:05 東京電力のタイムテーブルの２回目の括弧付けをやめ、表示しないようにした。</li>
<li>2011/6/07 05:40 東京電力のタイムテーブルが、やむを得ず計画停電を実施する場合の予定表の２回目が実行されないようなので括弧付けにした。</li>
<li>2011/6/05 17:00 節電の心得がTOPに出るように変更 (PC版のみ)、その他節電の心得の追記、情報ソース元を記載</li>
<li>2011/6/01 06:00 節電の心得一部変更</li>
<li>2011/5/29 19:30 データ更新ではないが、「世界中から日本へ送る応援メッセージ」への動画のリンクをした(PCのみ)</li>
<li>2011/5/24 07:30 節電の心得のエアコンについて追記</li>
<li>2011/5/24 07:30 節電の心得をテレビ、パソコンを分離した。</li>
<li>2011/5/24 19:15 他の節電ソフトも紹介しました。</li>
<li>2011/5/24 19:02 Microsoftの節電策に、節電の心得の中にリンクした</li>
<li>2011/5/24 17:43 電力売り上げ実績サイトへリンクした(PC向けのみ)</li>
<li>2011/5/24 15:23 節電事例に、更に予算がある方へのソーラーパネル設置による売電、及び屋上緑化における節電ケースを掲載した</li>
<li>2011/5/23 02:45 6月30日分までのテーブルを追記した。</li>
<li>2011/5/23 01:23 東京電力より新たな具体的な節電事例が追加されたため追記した</li>
EOM

my $engine_update=<<EOM;
<li>2011/7/02 05:00 東京電力のでんき予報の昨日のデータ閲覧、及び、過去３年間のデータ（同日）を閲覧できるようにした。また、使用率に応じて色を変更するようにした。</li>
<li>2011/7/01 03:00 東京電力のでんき予報に対応。11:32追記：ダウンロードファイル名が誤っていたのを修正。</li>
<li>2011/6/30 19:29 東京電力電力使用率グラフのCSVデータを一時的に旧フォーマットで提供されているものに一時変更した。</li>
<li>2011/6/24 19:56 TOPページにおけるSEO対策が不十分であることが確かめられたので変更した。</li>
<li>2011/6/22 13:43 電力使用状況予想時間が更新されることがあるので、更新時刻を表記した。また、パーセントで表記するようにした。</li>
<li>2011/6/21 19:02 東京電力、東北電力共に、公式のグラフサイトにリンクをした（東北電力英語を除く）</li>
<li>2011/6/16 21:08 東北電力の使用状況を見れるようにした。</li>
<li>2011/6/15 13:15 当日と前日の差が0万kwの時に差が表示されないのを修正した</li>
<li>2011/6/11 05:05 ↓キャッシュ制御を改めて修正した</li>
<li>2011/6/10 17:45 ↓キャッシュ制御にバグがあった為修正</li>
<li>2011/6/10 15:45 東京電力の使用状況をPC、及びモバイル、及び英語で見れるようにした。</li>
<li>2011/6/10 07:12 東京電力の使用状況を現状PCのみで見れるようにした。いずれ英語、携帯、RSS出力に対応します。</li>
<li>2011/4/23 16:12 一部のモバイル「開発環境」において、それなりの判定を出来なかったのを修正</li>
<li>2011/4/06 10:49 モバイル向けのHTML出力をわずかに変更した</li>
<li>2011/4/05 19:15 町名を入力しない場合、グループの計画停電時間の一覧を表示するようにした。</li>
<li>2011/4/03 18:00 サブグループを含めた検索を再検証し、実装しなおした。また、area.html、及び area.xml 化をした。</li>
<li>2011/4/02 11:01 サブグループも含めた検索を実装した。携帯の出力を変更した。</li>
EOM

#------------
use Encode;
require "common.pl";

$VER=~s/\(.*//g;
my $nojapaneseflg=0;
$nojapaneseflg=1 if($ENV{HTTP_ACCEPT_LANGUAGE}=~/en/);
my $mobileflg=0;
$mobileflg=1 if($ENV{HTTP_USER_AGENT}=~/DoCoMo|UP\.Browser|KDDI|SoftBank|Voda[F|f]one|J\-PHONE|DDIPOCKET|WILLCOM|iPod|PDA|Mobile|Semulator/);

$mobileflg=0 if($ENV{QUERY_STRING}=~'p');
$mobileflg=1 if($ENV{QUERY_STRING}=~'m');
$nojapaneseflg=0 if($ENV{QUERY_STRING}=~'j');
$nojapaneseflg=1 if($ENV{QUERY_STRING}=~'e');

my $english_file="english.html";
my $english_mobile_file="english_mobile.html";
my $mobile_file="mobile.html";
my $pc_file="pc.html";
my $mobile_update_file="mobile_update.html";
my $mobile_setuden_file="mobile_setuden.html";

&gzip_compress("Content-type: text/html; charset=utf-8");
my $body;
my $file;
my $kanaflg=0;
my $updatetitle;
if($nojapaneseflg) {
	if($mobileflg) {
		$file=$english_mobile_file;
	} else {
		$file=$english_file;
	}
} elsif($ENV{QUERY_STRING}=~/^mju/) {
	$file=$mobile_update_file;
	$kanaflg=1;
} elsif($ENV{QUERY_STRING}=~/^mjs/) {
	$file=$mobile_setuden_file;
	$kanaflg=1;
} elsif($mobileflg) {
	$file=$mobile_file;
	$kanaflg=1;
} else {
	$file=$pc_file;
}

if(open(R,"<:utf8","$file")) {
	foreach(<R>) {
		if(/\@\@/) {
			s/\@\@VER\@\@/$VER/;
			s/\@\@INCLUDE\=\"(.+)\"\@\@/@{[&include($1)]}/;
			s/\@\@QRCODEEN\@\@/@{[&qrcode_link_en]}/;
			s/\@\@QRCODEJP\@\@/@{[&qrcode_link]}/;
			s/\@\@DATAUPDATE\@\@/$data_update/;
			s/\@\@ENGINEUPDATE\@\@/$engine_update/;
			s/\@\@TARBALL\@\@/$tarball/;
		}
		$body.=$_;
	}
	close(R);
} else {
	$body="$file not found. sorry.";
}
if($kanaflg) {
	$body=&z2h($body);
}
print "$body\n";
close(STDOUT);
exit;

sub include {
	my $file=shift;
	my $body="";
	if(open(I,"<:utf8","$file")) {
		my $div=$file;
		$div=~s/\.//g;
		$body.=<<EOM;
<div id="$div">
EOM
		foreach(<I>) {
			$body.=$_;
		}
		close(I);
		$body.="</div>\n";
	}
	$body;
}

sub qrcode_link {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath");
	if(&load_module("GD") && &load_module("GD::Barcode")) {
		return <<FIN;
携帯へURLを送るには、こちらのQRコードをご利用下さい。<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub qrcode_link_en {
	my($basehref, $basehost, $basepath)=&getbasehref;
	my $string=&enc("$basehost$basepath?e");
	if(&load_module("GD::Barcode")) {
		return <<FIN;
If you have mobile phone to transfer this site, use this barcode.
<br />
<img alt="QRCode" src="$basehost$basepath/area.cgi?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

